#include <stdio.h>
#include <stdlib.h>

#include "f2c.h"

 int main(void)
{
    /* System generated locals */
    int i__1, i__2, i__3;

    /* Builtin functions */
    double cos(double), sin(double);

    /* Local variables */
    extern int f_c();
    static double h__;
    static int j, l, m, k;
    static double p[65], q, s[77], u[22] /* was [2][11] */, x, x1,
            au[28] /* was [2][14] */, du[22] /* was [2][11] */, xk;
    static int nx;
    static double xp, yp[2], yt[2], yx[2];
    static int kp1, kp2, kp3;
    static double xj0[11], ajk[24] /* was [2][12] */, adu[26] /* was [2][13] */,
                  alp[11], zfi[28] /* was [2][14] */, dyp[2],
           	  dyt[2], dyx[2], hd4i[12], rabc[11];
    extern int de78d_c( );
    static double cmar[121] /* was [11][11] */, ajkp[24] /* was [2][12] */,
                  alpn[11], dely[2];
    static int imax;
    static double rabc1[11], rabc2[13], rabc3[13], deldy[2];
    static int iniapr, jstart;

    m = 2;
    q = .5;
    x = 0.f;
    yx[0] = cos(q) + 3.;
    yx[1] = -sin(q) + 2.;
    dyx[0] = q * 2. * sin(q);
    dyx[1] = q * 2. * cos(q);
    h__ = 1.;
    xk = x + h__;
    x1 = xk * 2. - 1.;
    yt[0] = cos(q * x1) + 3.;
    yt[1] = sin(q * x1) + 2.;
    dyt[0] = q * -2. * sin(q * x1);
    dyt[1] = q * 2. * cos(q * x1);
    imax = 16;
    jstart = 0;
    iniapr = 1;
    k = 11;

    de78d_c((U_fp)f_c, &m, &k, &iniapr, &imax, &jstart, yx, dyx, &x, xj0,
	    au, adu, ajk, &h__, hd4i, rabc, rabc1, rabc2, rabc3, alp, alpn,
	    cmar, p, s, &xp, yp, dyp, ajkp, u, du, zfi);

    dely[0] = yt[0] - yx[0];
    dely[1] = yt[1] - yx[1];
    deldy[0] = dyt[0] - dyx[0];
    deldy[1] = dyt[1] - dyx[1];

    printf("\n ------------------------------------------------------------\n");
    printf("\n xp= %21.14e  x= %21.14e \n\n",xp, x);

    printf("\n h=%21.14e k =%3i iniapr= %1i imax=%3i jstart=%3i\n\n", h__, k,iniapr,imax,jstart);

    printf("\n yx= %21.14e %21.14e\n", yx[0], yx[1]);
    printf("\n yt= %21.14e %21.14e\n",yt[0], yt[1]);
    printf("\n dely= %23.14e %21.14e\n\n", dely[0], dely[1]);

    printf("\n dyx= %21.14e %21.14e\n",dyx[0], dyx[1]);
    printf("\n dyt= %21.14e %21.14e\n",dyt[0], dyt[1]);
    printf("\n deldy= %23.14e %21.14e \n", deldy[0], deldy[1]);

    printf("\n ***********************************************************\n");

    nx = 1;
    kp3 = 14;
    kp2 = 13;
    kp1 = 12;

    printf("\n\n  COEFFICIENTS AU, ADU AND AJK ON %3i SEGMENT \n", nx);

    i__1 = m;
    for (l = 1; l <= i__1; ++l) {

    printf("\n                  Chebyshev coefficients  for %i component \n", l);
    printf("\n              for Y                   for  Y'                for Y'' \n");

	i__2 = kp1;
	for (j = 1; j <= i__2; ++j) {
	    i__3 = j - 1;

         printf("\n %3i %23.14e %23.14e %23.14e", i__3, au[l + (j << 1) - 3], adu[l + (j << 1) - 3], ajk[l + (j << 1) - 3]);
	}
         printf("\n %3i %23.14e %23.14e", kp1, au[l + (kp2 << 1) - 3], adu[l + (kp2 << 1) - 3]);
         printf("\n %3i %23.14e \n", kp2, au[l + (kp3 << 1) - 3]);
    }
    return 0;
} /* main */


 int f_c(double *x, double *y, double *dy,
	double *z__, int *m)
{
    /* System generated locals */
    double d__1;

    /* Builtin functions */
    double exp(double);

    /* Local variables */
    static real q;

    /* Parameter adjustments */
    --z__;
    --dy;
    --y;

    /* Function Body */
    q = .5f;
/* Computing 2nd power */
    d__1 = (1. - exp(3. - y[1] + dy[2] * .5 / q)) / (*x + 1.);
    z__[1] = q * -2. * dy[2] - d__1 * d__1;
/* Computing 2nd power */
    d__1 = dy[2] - q * 2. * (y[1] - 3.);
    z__[2] = q * 2. * dy[1] - d__1 * d__1;
    return 0;
} /* f_c */


/* Common Block Declarations */

struct {
    double wc1, wc2, wc3, hd2, hd4, hold;
    int lasn;
} com70d_;

#define com70d_1 com70d_

struct {
    int jlas, jlas1, jlas2, jlas3;
    double h2d4, h2d8, h2d16, h2d32, h2d96;
} com80d_;

#define com80d_1 com80d_

/* Subroutine */ int de78d_c(S_fp f, integer *m, integer *k, integer *iniapr,
	integer *imax, integer *jstart, doublereal *yx, doublereal *dyx,
	doublereal *x, doublereal *xj0, doublereal *au, doublereal *adu,
	doublereal *ajk, doublereal *h__, doublereal *hd4i, doublereal *rabc,
	doublereal *rabc1, doublereal *rabc2, doublereal *rabc3, doublereal *
	alp, doublereal *alpn, doublereal *cmar, doublereal *p, doublereal *s,
	 doublereal *xp, doublereal *yp, doublereal *dyp, doublereal *ajkp,
	doublereal *u, doublereal *du, doublereal *zfi)
{
    /* System generated locals */
    integer au_dim1, au_offset, adu_dim1, adu_offset, ajk_dim1, ajk_offset,
	    cmar_dim1, cmar_offset, ajkp_dim1, ajkp_offset, u_dim1, u_offset,
	    du_dim1, du_offset, zfi_dim1, zfi_offset, i__1, i__2;

    /* Local variables */
    static integer j, l, nu, kp1, kp2;
    static doublereal ksi;
    extern /* Subroutine */ int de80d0_c(S_fp, integer *, integer *,
	    doublereal *, doublereal *, doublereal *, doublereal *,
	    doublereal *, doublereal *, doublereal *, doublereal *,
	    doublereal *, doublereal *, doublereal *, doublereal *), de71de_c(
	    integer *, integer *, doublereal *, doublereal *, doublereal *,
	    doublereal *), de71df_c(integer *, integer *, doublereal *,
	    doublereal *, doublereal *), de70dh_c(integer *, doublereal *,
	    doublereal *), de80dh_c(integer *, doublereal *), de80di_c(S_fp,
	    integer *, integer *, integer *, doublereal *, doublereal *,
	    doublereal *, doublereal *, doublereal *, doublereal *,
	    doublereal *, doublereal *, doublereal *, doublereal *,
	    doublereal *, doublereal *, doublereal *, doublereal *,
	    doublereal *, doublereal *), de70dk_c(integer *, doublereal *,
	    doublereal *, doublereal *, doublereal *, doublereal *,
	    doublereal *), de80dk_c(integer *, doublereal *, doublereal *,
	    doublereal *), de70df_c(integer *, integer *, doublereal *,
	    doublereal *);
    static integer iexit;

    /* Parameter adjustments */
    zfi_dim1 = *m;
    zfi_offset = 1 + zfi_dim1;
    zfi -= zfi_offset;
    ajkp_dim1 = *m;
    ajkp_offset = 1 + ajkp_dim1;
    ajkp -= ajkp_offset;
    --dyp;
    --yp;
    ajk_dim1 = *m;
    ajk_offset = 1 + ajk_dim1;
    ajk -= ajk_offset;
    adu_dim1 = *m;
    adu_offset = 1 + adu_dim1;
    adu -= adu_offset;
    au_dim1 = *m;
    au_offset = 1 + au_dim1;
    au -= au_offset;
    --dyx;
    --yx;
    du_dim1 = *m;
    du_offset = 1 + du_dim1;
    du -= du_offset;
    u_dim1 = *m;
    u_offset = 1 + u_dim1;
    u -= u_offset;
    cmar_dim1 = *k;
    cmar_offset = 1 + cmar_dim1;
    cmar -= cmar_offset;
    --alpn;
    --alp;
    --rabc1;
    --rabc;
    --xj0;
    --hd4i;
    --rabc2;
    --rabc3;
    --p;
    --s;

    /* Function Body */
    kp1 = *k + 1;
    kp2 = *k + 2;
    *xp = *x;
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
	yp[l] = yx[l];
/* L45: */
	dyp[l] = dyx[l];
    }
    if (*jstart != 0) {
	goto L55;
    }

/*       THE FIRST STEP REALIZATION */
/*       CALCULATION OF ALL VARIABLES DEPENDING ON K */

    de70dk_c(k, &rabc[1], &alp[1], &alpn[1], &cmar[cmar_offset], &p[1], &s[1]);
    de80dk_c(k, &rabc1[1], &rabc2[1], &rabc3[1]);

/*       CALCULATION OF ALL VARIABLES DEPENDING ON H */
/*       AND ALSO VARIABLES DEPENDING ON H AND K */

    de70dh_c(k, h__, &hd4i[1]);
    de80dh_c(k, h__);

    i__1 = *k;
    for (j = 1; j <= i__1; ++j) {
/* L50: */
	xj0[j] = *xp + alp[j] * *h__;
    }
    de80d0_c((S_fp)f, m, k, xp, &yp[1], &dyp[1], &xj0[1], &alpn[1], &cmar[
	    cmar_offset], &ajk[ajk_offset], &au[au_offset], &adu[adu_offset],
	    &u[u_offset], &du[du_offset], &zfi[zfi_offset]);
    goto L110;

/*       THE NEXT STEP REALIZATION */

L55:
    i__1 = *k;
    for (j = 1; j <= i__1; ++j) {
/* L60: */
	xj0[j] = *xp + alp[j] * *h__;
    }

/*       CHEBYSHEV COEFFICIENTS FROM PREVIOUS STEP STORAGE */
    i__1 = kp1;
    for (j = 1; j <= i__1; ++j) {
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
/* L65: */
	    ajkp[l + j * ajkp_dim1] = ajk[l + j * ajk_dim1];
	}
/* L70: */
    }

    if (*h__ == com70d_1.hold) {
	goto L80;
    }
    ksi = *h__ / com70d_1.hold;

/*       RECALCULATION 0F ALL VARIABLES DEPENDING ON H */

    de70dh_c(k, h__, &hd4i[1]);
    de80dh_c(k, h__);

L80:
    if (*iniapr != 1) {
	goto L85;
    }

/*       CALCULATE INITIAL APPROXIMATION FROM INITIAL CONDITION ALWAYS */

    de80d0_c((S_fp)f, m, k, xp, &yp[1], &dyp[1], &xj0[1], &alpn[1], &cmar[
	    cmar_offset], &ajk[ajk_offset], &au[au_offset], &adu[adu_offset],
	    &u[u_offset], &du[du_offset], &zfi[zfi_offset]);
    goto L110;

/*       CALCULATE INITIAL APPROXIMATION BY EXTRAPOLATION OF COEFFICIENTS */
/*       AJK FROM PREVIOUS STEP */

L85:
    if (*h__ == com70d_1.hold) {
	goto L90;
    }
    de71de_c(m, k, &p[1], &ajk[ajk_offset], &ksi, &zfi[kp2 * zfi_dim1 + 1]);
    goto L95;
L90:
    de71df_c(m, k, &s[1], &ajk[ajk_offset], &zfi[kp2 * zfi_dim1 + 1]);

L95:
    (*f)(xp, &yp[1], &dyp[1], &zfi[zfi_dim1 + 1], m);
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
/* L100: */
	zfi[l + zfi_dim1] *= com70d_1.wc2;
    }

L110:
    iexit = 0;
    i__1 = *imax;
    for (nu = 1; nu <= i__1; ++nu) {
	de80di_c((S_fp)f, m, k, &iexit, &yp[1], &dyp[1], &xj0[1], &ajk[
		ajk_offset], &hd4i[1], &rabc[1], &rabc1[1], &rabc2[1], &rabc3[
		1], &alpn[1], &cmar[cmar_offset], &au[au_offset], &adu[
		adu_offset], &u[u_offset], &du[du_offset], &zfi[zfi_offset]);
/* L120: */
    }
    iexit = 3;
    de80di_c((S_fp)f, m, k, &iexit, &yp[1], &dyp[1], &xj0[1], &ajk[ajk_offset],
	     &hd4i[1], &rabc[1], &rabc1[1], &rabc2[1], &rabc3[1], &alpn[1], &
	    cmar[cmar_offset], &au[au_offset], &adu[adu_offset], &u[u_offset],
	     &du[du_offset], &zfi[zfi_offset]);

    de70df_c(m, &kp1, &adu[adu_offset], &dyx[1]);
    de70df_c(m, &kp2, &au[au_offset], &yx[1]);
    *x = *xp + *h__;
    com70d_1.hold = *h__;
    *jstart = 1;
/* L200: */
    return 0;
} /* de78d_c */


/* Subroutine */ int de70da_c(integer *m, integer *n, doublereal *aw)
{
    /* System generated locals */
    integer aw_dim1, aw_offset, i__1, i__2, i__3;

    /* Local variables */
    static integer j, k, l, j1, nm1, np1;

    /* Parameter adjustments */
    aw_dim1 = *m;
    aw_offset = 1 + aw_dim1;
    aw -= aw_offset;

    /* Function Body */
    np1 = *n + 1;
    nm1 = *n - 1;
    i__1 = nm1;
    for (j1 = 1; j1 <= i__1; ++j1) {
	j = np1 - j1;
/*          J - NUMBER OF COEFFICIENT */
	i__2 = *n;
	for (k = j; k <= i__2; ++k) {
	    i__3 = *m;
	    for (l = 1; l <= i__3; ++l) {
		aw[l + (k + 1) * aw_dim1] *= .5;
		aw[l + (k - 1) * aw_dim1] += aw[l + (k + 1) * aw_dim1];
/* L10: */
	    }
/* L20: */
	}
/* L30: */
    }
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
/* L40: */
	aw[l + aw_dim1] *= 2.;
    }
    return 0;
} /* de70da_c */

/* Subroutine */ int de70dc_c(integer *m, integer *n, doublereal *x,
                              doublereal *aw, doublereal *w, doublereal *bk)
{
    /* System generated locals */
    integer aw_dim1, aw_offset, bk_dim1, bk_offset, i__1, i__2;

    /* Local variables */
    static integer j, k, l;
    static doublereal x2;
    static integer np2;

    /* Parameter adjustments */
    bk_dim1 = *m;
    bk_offset = 1 + bk_dim1;
    bk -= bk_offset;
    --w;
    aw_dim1 = *m;
    aw_offset = 1 + aw_dim1;
    aw -= aw_offset;

    /* Function Body */
    np2 = *n + 2;
    x2 = *x + *x;
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
	bk[l + bk_dim1] = 0.f;
/* L5: */
	bk[l + (bk_dim1 << 1)] = 0.f;
    }
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
	k = np2 - j;
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
	    w[l] = bk[l + (bk_dim1 << 1)];
	    bk[l + (bk_dim1 << 1)] = bk[l + bk_dim1];
	    bk[l + bk_dim1] = aw[l + k * aw_dim1] - w[l] + bk[l + (bk_dim1 <<
		    1)] * x2;
/* L10: */
	}
/* L15: */
    }
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
	w[l] = aw[l + aw_dim1] * .5 - bk[l + (bk_dim1 << 1)] + bk[l + bk_dim1]
		 * *x;
/* L20: */
    }
    return 0;
} /* de70dc_c */

/* Subroutine */ int de70df_c(integer *m, integer *n, doublereal *aw,
                              doublereal *saw)
{
    /* System generated locals */
    integer aw_dim1, aw_offset, i__1, i__2;

    /* Local variables */
    static integer j, l, jn, np2;

    /* Parameter adjustments */
    --saw;
    aw_dim1 = *m;
    aw_offset = 1 + aw_dim1;
    aw -= aw_offset;

    /* Function Body */
    np2 = *n + 2;
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
/* L10: */
	saw[l] = 0.f;
    }
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
	jn = np2 - j;
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
/* L15: */
	    saw[l] += aw[l + jn * aw_dim1];
	}
/* L20: */
    }
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
/* L25: */
	saw[l] += aw[l + aw_dim1] * .5;
    }
    return 0;
} /* de70df_c */

/* Subroutine */ int de70dh_c(integer *k, doublereal *h__, doublereal *hd4i)
{
    /* System generated locals */
    integer i__1;

    /* Local variables */
    static integer i__, kp1;

    /* Parameter adjustments */
    --hd4i;

    /* Function Body */
    com70d_1.hd2 = *h__ * .5;
    com70d_1.hd4 = *h__ * .25;
    kp1 = *k + 1;
    i__1 = kp1;
    for (i__ = 1; i__ <= i__1; ++i__) {
/* L10: */
	hd4i[i__] = com70d_1.hd4 / (doublereal) i__;
    }
    return 0;
} /* de70dh_c */

/* Subroutine */ int de70dk_c(integer *k, doublereal *rabc, doublereal *alp,
	doublereal *alpn, doublereal *cmar, doublereal *p, doublereal *s)
{
    /* System generated locals */
    integer cmar_dim1, cmar_offset, i__1, i__2;

    /* Builtin functions */
    double cos(doublereal);

    /* Local variables */
    static integer i__, j;
    static doublereal r__, w, pi;
    static integer jm1, km1;
    static doublereal wc0;
    static integer ipn, ipns;

    /* Parameter adjustments */
    cmar_dim1 = *k;
    cmar_offset = 1 + cmar_dim1;
    cmar -= cmar_offset;
    --alpn;
    --alp;
    --rabc;
    --p;
    --s;

    /* Function Body */
    pi = 3.1415926535897932385;
/*     PI=3.14_159_265_358_979_323_85 */
/*       CONSTRUCTION OF PASCAL MATRIX */
    km1 = *k - 1;
    i__1 = km1;
    for (j = 1; j <= i__1; ++j) {
/* L10: */
	cmar[j + j * cmar_dim1] = 1.;
    }
    i__1 = *k;
    for (j = 2; j <= i__1; ++j) {
	cmar[j * cmar_dim1 + 1] = (doublereal) j;
	if (j == 2) {
	    goto L20;
	}
	jm1 = j - 1;
	i__2 = jm1;
	for (i__ = 2; i__ <= i__2; ++i__) {
	    cmar[i__ + j * cmar_dim1] = cmar[i__ - 1 + jm1 * cmar_dim1] +
		    cmar[i__ + jm1 * cmar_dim1];
/* L15: */
	}
L20:
	;
    }
/*       DISPLACEMENT OF PASCAL MATRIX */
    s[1] = 1.;
    i__1 = *k;
    for (j = 1; j <= i__1; ++j) {
/* L25: */
	s[j + 1] = s[j] * 2.;
    }
    ipns = *k + 1;
    ipn = 0;
    i__1 = km1;
    for (i__ = 1; i__ <= i__1; ++i__) {
	r__ = .5;
	i__2 = *k;
	for (j = i__; j <= i__2; ++j) {
	    ++ipn;
	    ++ipns;
	    p[ipn] = cmar[i__ + j * cmar_dim1];
	    r__ *= 2.;
	    s[ipns] = cmar[i__ + j * cmar_dim1] * r__;
/* L30: */
	}
/* L35: */
    }
/*       CALCULATE OF MARKOV COEFFICIENTS */
    wc0 = 1. / (doublereal) ((*k << 1) + 1);
    com70d_1.wc1 = pi * wc0;
    com70d_1.wc2 = wc0 * 2.;
    com70d_1.wc3 = wc0 * 4.;
    com70d_1.lasn = *k + 1 - *k % 2;
/*       COEFFICIENTS MARKOV FOR A1 */
    i__1 = *k;
    for (j = 1; j <= i__1; ++j) {
	w = (doublereal) ((j << 1) - 1) * com70d_1.wc1;
	alpn[j] = cos(w);
	alp[j] = (alpn[j] + 1.) * .5;
	cmar[j * cmar_dim1 + 1] = alpn[j];
/* L40: */
    }
/*       COEFFICIENTS MARKOV FOR A2,...,AK */
    i__1 = *k;
    for (j = 1; j <= i__1; ++j) {
	r__ = (doublereal) ((j << 1) - 1) * com70d_1.wc1;
	i__2 = *k;
	for (i__ = 2; i__ <= i__2; ++i__) {
	    cmar[i__ + j * cmar_dim1] = cos((doublereal) i__ * r__);
/*       CMAR(I,J)=DE70DT(I,ALPN(J)) */
/* L50: */
	}
/* L55: */
    }
    i__1 = *k;
    for (j = 2; j <= i__1; ++j) {
	rabc[j] = 1. / (doublereal) (j * j - 1);
/* L60: */
    }
    return 0;
} /* de70dk_c */

/* Subroutine */ int de70dp_c(integer *m, integer *n, doublereal *cw)
{
    /* System generated locals */
    integer cw_dim1, cw_offset, i__1, i__2, i__3;

    /* Local variables */
    static integer j, k, l, k1, nj;

    /* Parameter adjustments */
    cw_dim1 = *m;
    cw_offset = 1 + cw_dim1;
    cw -= cw_offset;

    /* Function Body */
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
/* L10: */
	cw[l + cw_dim1] *= .5;
    }
    i__1 = *n;
    for (j = 2; j <= i__1; ++j) {
	nj = *n + j;
	i__2 = *n;
	for (k1 = j; k1 <= i__2; ++k1) {
	    k = nj - k1;
/*       K - NUMBER OF COEFFICIENT */
	    i__3 = *m;
	    for (l = 1; l <= i__3; ++l) {
		cw[l + (k - 1) * cw_dim1] -= cw[l + (k + 1) * cw_dim1];
		cw[l + (k + 1) * cw_dim1] *= 2.;
/* L20: */
	    }
/* L30: */
	}
/* L40: */
    }
    return 0;
} /* de70dp_c */

/* Subroutine */ int de70dq_c(integer *m, integer *n, doublereal *zfi,
	doublereal *cmar, doublereal *ajk)
{
    /* System generated locals */
    integer zfi_dim1, zfi_offset, cmar_dim1, cmar_offset, ajk_dim1,
	    ajk_offset, i__1, i__2, i__3;

    /* Local variables */
    static integer i__, j, l, i1, jp1, np1;

    /* Parameter adjustments */
    ajk_dim1 = *m;
    ajk_offset = 1 + ajk_dim1;
    ajk -= ajk_offset;
    zfi_dim1 = *m;
    zfi_offset = 1 + zfi_dim1;
    zfi -= zfi_offset;
    cmar_dim1 = *n;
    cmar_offset = 1 + cmar_dim1;
    cmar -= cmar_offset;

    /* Function Body */
    np1 = *n + 1;
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
/* L10: */
	ajk[l + np1 * ajk_dim1] = 0.f;
    }
/*        CALCULATE AJ0 */
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
	jp1 = j + 1;
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
	    ajk[l + np1 * ajk_dim1] += zfi[l + jp1 * zfi_dim1];
/* L20: */
	}
/* L30: */
    }
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
/* L40: */
	ajk[l + ajk_dim1] = zfi[l + zfi_dim1] + com70d_1.wc3 * ajk[l + np1 *
		ajk_dim1];
    }
/*        CALCULATE AJ1,AJ3,AJ5,... */
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; i__ += 2) {
	i1 = i__ + 1;
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
/* L50: */
	    ajk[l + np1 * ajk_dim1] = 0.f;
	}
	i__2 = *n;
	for (j = 1; j <= i__2; ++j) {
	    jp1 = j + 1;
	    i__3 = *m;
	    for (l = 1; l <= i__3; ++l) {
		ajk[l + np1 * ajk_dim1] += cmar[i__ + j * cmar_dim1] * zfi[l
			+ jp1 * zfi_dim1];
/* L60: */
	    }
/* L70: */
	}
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
/* L80: */
	    ajk[l + i1 * ajk_dim1] = -zfi[l + zfi_dim1] + com70d_1.wc3 * ajk[
		    l + np1 * ajk_dim1];
	}
/* L90: */
    }
/*        CALCULATE AJ2,AJ4,AJ6,... */
    i__1 = *n;
    for (i__ = 2; i__ <= i__1; i__ += 2) {
	i1 = i__ + 1;
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
/* L100: */
	    ajk[l + com70d_1.lasn * ajk_dim1] = 0.f;
	}
	i__2 = *n;
	for (j = 1; j <= i__2; ++j) {
	    jp1 = j + 1;
	    i__3 = *m;
	    for (l = 1; l <= i__3; ++l) {
		ajk[l + com70d_1.lasn * ajk_dim1] += cmar[i__ + j * cmar_dim1]
			 * zfi[l + jp1 * zfi_dim1];
/* L110: */
	    }
/* L120: */
	}
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
/* L130: */
	    ajk[l + i1 * ajk_dim1] = zfi[l + zfi_dim1] + com70d_1.wc3 * ajk[l
		    + com70d_1.lasn * ajk_dim1];
	}
/* L140: */
    }
    return 0;
} /* de70dq_c */

/* Subroutine */ int de71df_c(integer *m, integer *k, doublereal *s,
	doublereal *aw, doublereal *rab)
{
    /* System generated locals */
    integer aw_dim1, aw_offset;

    /* Local variables */
    extern /* Subroutine */ int de70da_c(integer *, integer *, doublereal *),
	    de70dp_c(integer *, integer *, doublereal *),
            de71ds_c(integer *, integer *, doublereal *, doublereal *, doublereal *);

    /* Parameter adjustments */
    --rab;
    aw_dim1 = *m;
    aw_offset = 1 + aw_dim1;
    aw -= aw_offset;
    --s;

    /* Function Body */
    de70dp_c(m, k, &aw[aw_offset]);
    de71ds_c(m, k, &s[1], &aw[aw_offset], &rab[1]);
    de70da_c(m, k, &aw[aw_offset]);
    return 0;
} /* de71df_c */

/* Subroutine */ int de71de_c(integer *m, integer *k, doublereal *p,
	doublereal *aw, doublereal *ksi, doublereal *rab)
{
    /* System generated locals */
    integer aw_dim1, aw_offset;

    /* Local variables */
    extern /* Subroutine */ int de70da_c(integer *, integer *, doublereal *),
	    de71di_c(integer *, integer *, doublereal *, doublereal *),
	    de70dp_c(integer *, integer *, doublereal *),
            de71dp_c(integer *, integer *, doublereal *, doublereal *, doublereal *),
            de71dt_c(integer *, integer *, doublereal *, doublereal *);

    /* Parameter adjustments */
    --rab;
    aw_dim1 = *m;
    aw_offset = 1 + aw_dim1;
    aw -= aw_offset;
    --p;

    /* Function Body */
    de70dp_c(m, k, &aw[aw_offset]);
    de71dt_c(m, k, &aw[aw_offset], ksi);
    de71dp_c(m, k, &p[1], &aw[aw_offset], &rab[1]);
    de71di_c(m, k, &aw[aw_offset], ksi);
    de70da_c(m, k, &aw[aw_offset]);
    return 0;
} /* de71de_c */

/* Subroutine */ int de71dp_c(integer *m, integer *k, doublereal *p,
	                      doublereal *z__, doublereal *rab)
{
    /* System generated locals */
    integer z_dim1, z_offset, i__1, i__2, i__3;

    /* Local variables */
    static integer i__, j, l, j1, jn, ip, kp1, kp2, ipn;

    /* Parameter adjustments */
    --rab;
    z_dim1 = *m;
    z_offset = 1 + z_dim1;
    z__ -= z_offset;
    --p;

    /* Function Body */
    kp1 = *k + 1;
    kp2 = *k + 2;
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
/* L5: */
	rab[l] = z__[l + kp1 * z_dim1];
    }
    i__1 = *k;
    for (j = 1; j <= i__1; ++j) {
	j1 = kp1 - j;
/*         J1 - A NUMBER OF COLUMN OF Z */
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
/* L10: */
	    rab[l] += z__[l + j1 * z_dim1];
	}
/* L15: */
    }
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
/* L20: */
	z__[l + z_dim1] = rab[l];
    }
    ipn = 1;
    i__1 = *k;
    for (i__ = 2; i__ <= i__1; ++i__) {
	jn = kp2 - i__;
	ip = ipn + jn;
	ipn = ip;
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
/* L25: */
	    rab[l] = 0.f;
	}
	i__2 = jn;
	for (j = 1; j <= i__2; ++j) {
	    j1 = kp2 - j;
	    --ip;
	    i__3 = *m;
	    for (l = 1; l <= i__3; ++l) {
/* L30: */
		rab[l] += p[ip] * z__[l + j1 * z_dim1];
	    }
/* L35: */
	}
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
/* L40: */
	    z__[l + i__ * z_dim1] = rab[l];
	}
/* L50: */
    }
/*         THE LAST COLUMN OF Z IS NOT CHANGED */
    return 0;
} /* de71dp_c */

/* Subroutine */ int de71di_c(integer *m, integer *k, doublereal *z__,
	                      doublereal *ksi)
{
    /* System generated locals */
    integer z_dim1, z_offset, i__1, i__2;

    /* Local variables */
    static integer j, l;
    static doublereal t, ksif;

    /* Parameter adjustments */
    z_dim1 = *m;
    z_offset = 1 + z_dim1;
    z__ -= z_offset;

    /* Function Body */
    t = 1.;
    ksif = *ksi / (*ksi + 1.);
    i__1 = *k;
    for (j = 1; j <= i__1; ++j) {
	t *= ksif;
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
/* L10: */
	    z__[l + (j + 1) * z_dim1] *= t;
	}
/* L20: */
    }
    return 0;
} /* de71di_c */

/* Subroutine */ int de71dt_c(integer *m, integer *k, doublereal *z__,
	                      doublereal *ksi)
{
    /* System generated locals */
    integer z_dim1, z_offset, i__1, i__2;

    /* Local variables */
    static integer j, l;
    static doublereal t, ksi1;

    /* Parameter adjustments */
    z_dim1 = *m;
    z_offset = 1 + z_dim1;
    z__ -= z_offset;

    /* Function Body */
    t = 1.;
    ksi1 = *ksi + 1.;
    i__1 = *k;
    for (j = 1; j <= i__1; ++j) {
	t *= ksi1;
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
/* L10: */
	    z__[l + (j + 1) * z_dim1] *= t;
	}
/* L20: */
    }
    return 0;
} /* de71dt_c */


/* Subroutine */ int de71ds_c(integer *m, integer *k, doublereal *s,
	                      doublereal *z__, doublereal *rab)
{
    /* System generated locals */
    integer z_dim1, z_offset, i__1, i__2, i__3;

    /* Local variables */
    static integer i__, j, l, j1, jn, ip, kp2, ipn;

    /* Parameter adjustments */
    --rab;
    z_dim1 = *m;
    z_offset = 1 + z_dim1;
    z__ -= z_offset;
    --s;

    /* Function Body */
    kp2 = *k + 2;
    ipn = 1;
    i__1 = *k;
    for (i__ = 1; i__ <= i__1; ++i__) {
	jn = kp2 - i__;
	ip = ipn + jn;
	ipn = ip;
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
/* L25: */
	    rab[l] = 0.f;
	}
	i__2 = jn;
	for (j = 1; j <= i__2; ++j) {
	    j1 = kp2 - j;
	    --ip;
	    i__3 = *m;
	    for (l = 1; l <= i__3; ++l) {
/* L30: */
		rab[l] += s[ip] * z__[l + j1 * z_dim1];
	    }
/* L35: */
	}
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
/* L40: */
	    z__[l + i__ * z_dim1] = rab[l];
	}
/* L50: */
    }
    return 0;
} /* de71ds_c */

/* Subroutine */ int de80d0_c(S_fp f, integer *m, integer *n, doublereal *x,
	doublereal *yx, doublereal *dyx, doublereal *xj0, doublereal *alpn,
	doublereal *cmar, doublereal *ajk, doublereal *au, doublereal *adu,
	doublereal *u, doublereal *du, doublereal *zfi)
{
    /* System generated locals */
    integer cmar_dim1, cmar_offset, ajk_dim1, ajk_offset, au_dim1, au_offset,
	    adu_dim1, adu_offset, u_dim1, u_offset, du_dim1, du_offset,
	    zfi_dim1, zfi_offset, i__1, i__2;

    /* Local variables */
    static integer j, l;
    static doublereal w1;
    extern /* Subroutine */ int de70dq_c(integer *, integer *, doublereal *,
	    doublereal *, doublereal *);

    /* Parameter adjustments */
    zfi_dim1 = *m;
    zfi_offset = 1 + zfi_dim1;
    zfi -= zfi_offset;
    adu_dim1 = *m;
    adu_offset = 1 + adu_dim1;
    adu -= adu_offset;
    au_dim1 = *m;
    au_offset = 1 + au_dim1;
    au -= au_offset;
    ajk_dim1 = *m;
    ajk_offset = 1 + ajk_dim1;
    ajk -= ajk_offset;
    --dyx;
    --yx;
    du_dim1 = *m;
    du_offset = 1 + du_dim1;
    du -= du_offset;
    u_dim1 = *m;
    u_offset = 1 + u_dim1;
    u -= u_offset;
    cmar_dim1 = *n;
    cmar_offset = 1 + cmar_dim1;
    cmar -= cmar_offset;
    --alpn;
    --xj0;

    /* Function Body */
    (*f)(x, &yx[1], &dyx[1], &zfi[zfi_dim1 + 1], m);
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
	ajk[l + ajk_dim1] = zfi[l + zfi_dim1] * 2.;
	adu[l + (adu_dim1 << 1)] = com70d_1.hd4 * ajk[l + ajk_dim1];
	adu[l + adu_dim1] = dyx[l] + adu[l + (adu_dim1 << 1)];
	au[l + au_dim1 * 3] = com80d_1.h2d32 * ajk[l + ajk_dim1];
	au[l + (au_dim1 << 1)] = com70d_1.hd2 * (dyx[l] + com70d_1.hd4 * ajk[
		l + ajk_dim1]);
	au[l + au_dim1] = yx[l] + com70d_1.hd2 * dyx[l] + com80d_1.h2d32 * 3.
		* ajk[l + ajk_dim1];
	zfi[l + zfi_dim1] *= com70d_1.wc2;
/* L10: */
    }
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
	w1 = alpn[j] * 2. * alpn[j] - 1.;
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
	    du[l + j * du_dim1] = adu[l + adu_dim1] + adu[l + (adu_dim1 << 1)]
		     * alpn[j];
	    u[l + j * u_dim1] = au[l + au_dim1] + au[l + (au_dim1 << 1)] *
		    alpn[j] + au[l + au_dim1 * 3] * w1;
/* L20: */
	}
	(*f)(&xj0[j], &u[j * u_dim1 + 1], &du[j * du_dim1 + 1], &zfi[(j + 1) *
		 zfi_dim1 + 1], m);
/* L30: */
    }
    de70dq_c(m, n, &zfi[zfi_offset], &cmar[cmar_offset], &ajk[ajk_offset]);
    return 0;
} /* de80d0_c */

/* Subroutine */ int de80dh_c(integer *k, doublereal *h__)
{
    com80d_1.h2d4 = *h__ * .25 * *h__;
    com80d_1.h2d8 = com80d_1.h2d4 * .5;
    com80d_1.h2d16 = com80d_1.h2d4 * .25;
    com80d_1.h2d32 = com80d_1.h2d4 * .125;
    com80d_1.h2d96 = com80d_1.h2d4 / 24.;
    return 0;
} /* de80dh_c */

/* Subroutine */ int de80di_c(S_fp f, integer *m, integer *k, integer *iexit,
	doublereal *yx, doublereal *dyx, doublereal *xj0, doublereal *ajk,
	doublereal *hd4i, doublereal *rabc, doublereal *rabc1, doublereal *
	rabc2, doublereal *rabc3, doublereal *alpn, doublereal *cmar,
	doublereal *au, doublereal *adu, doublereal *u, doublereal *du,
	doublereal *zfi)
{
    /* System generated locals */
    integer ajk_dim1, ajk_offset, cmar_dim1, cmar_offset, au_dim1, au_offset,
	    adu_dim1, adu_offset, u_dim1, u_offset, du_dim1, du_offset,
	    zfi_dim1, zfi_offset, i__1, i__2;

    /* Local variables */
    static integer i__, j, l, jl, im1, km1, km2, kp1, kp2, kp3, ip1, ip2, ip3;
    extern /* Subroutine */ int de70dc_(integer *, integer *, doublereal *,
	    doublereal *, doublereal *, doublereal *), de70dq_(integer *,
	    integer *, doublereal *, doublereal *, doublereal *);

    /* Parameter adjustments */
    zfi_dim1 = *m;
    zfi_offset = 1 + zfi_dim1;
    zfi -= zfi_offset;
    adu_dim1 = *m;
    adu_offset = 1 + adu_dim1;
    adu -= adu_offset;
    au_dim1 = *m;
    au_offset = 1 + au_dim1;
    au -= au_offset;
    ajk_dim1 = *m;
    ajk_offset = 1 + ajk_dim1;
    ajk -= ajk_offset;
    --dyx;
    --yx;
    du_dim1 = *m;
    du_offset = 1 + du_dim1;
    du -= du_offset;
    u_dim1 = *m;
    u_offset = 1 + u_dim1;
    u -= u_offset;
    cmar_dim1 = *k;
    cmar_offset = 1 + cmar_dim1;
    cmar -= cmar_offset;
    --alpn;
    --rabc1;
    --rabc;
    --xj0;
    --hd4i;
    --rabc2;
    --rabc3;

    /* Function Body */
    km1 = *k - 1;
    km2 = *k - 2;
    kp1 = *k + 1;
    kp2 = *k + 2;
    kp3 = *k + 3;
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
/* L10: */
	au[l + (au_dim1 << 1)] = 0.f;
    }

/*    CALCULATION SUM SIGMA */

    i__1 = *k;
    for (j = 2; j <= i__1; j += 2) {
	jl = com80d_1.jlas - j;
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
/* L15: */
	    au[l + (au_dim1 << 1)] -= ajk[l + (jl + 1) * ajk_dim1] * rabc[jl];
	}
/* L20: */
    }

    if (*k == 2) {
	goto L32;
    }

/*   THE COLUMN AU(L,3) IS USED AS WORKING ARRAY */

    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
/* L22: */
	au[l + au_dim1 * 3] = 0.f;
    }

    i__1 = *k;
    for (j = 3; j <= i__1; j += 2) {
	jl = com80d_1.jlas1 - j;
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
/* L25: */
	    au[l + au_dim1 * 3] += ajk[l + (jl + 1) * ajk_dim1] * rabc[jl];
	}
/* L30: */
    }

    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
/* L31: */
	au[l + (au_dim1 << 1)] += au[l + au_dim1 * 3];
    }
/* ------------------------------------------------------- */
L32:
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
	adu[l + adu_dim1] = (dyx[l] + com70d_1.hd4 * (ajk[l + ajk_dim1] - ajk[
		l + (ajk_dim1 << 1)] * .5) + com70d_1.hd2 * au[l + (au_dim1 <<
		 1)]) * 2.;
	adu[l + kp1 * adu_dim1] = hd4i[*k] * ajk[l + *k * ajk_dim1];
	adu[l + kp2 * adu_dim1] = hd4i[kp1] * ajk[l + kp1 * ajk_dim1];
/* L35: */
    }
    i__1 = km1;
    for (i__ = 1; i__ <= i__1; ++i__) {
	ip1 = i__ + 1;
	ip2 = i__ + 2;
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
/* L40: */
	    adu[l + ip1 * adu_dim1] = hd4i[i__] * (ajk[l + i__ * ajk_dim1] -
		    ajk[l + ip2 * ajk_dim1]);
	}
/* L45: */
    }

/*    CALCULATION SUM OF LAST TWO TERMS FOR J=K AND J=K-1 */

    if (*k % 2 != 0) {
	goto L60;
    } else {
	goto L50;
    }
L50:
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
/* L55: */
	au[l + au_dim1] = rabc1[km1] * ajk[l + *k * ajk_dim1] - rabc1[*k] *
		ajk[l + kp1 * ajk_dim1];
    }
    goto L70;
L60:
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
/* L65: */
	au[l + au_dim1] = -rabc1[km1] * ajk[l + *k * ajk_dim1] + rabc1[*k] *
		ajk[l + kp1 * ajk_dim1];
    }
/* ------------------------------------------------------- */
L70:
    if (*k == 2) {
	goto L95;
    }
    if (*k == 3) {
	goto L92;
    }

/*   CALCULATION THE LAST SUM */

    i__1 = km2;
    for (j = 2; j <= i__1; j += 2) {
	jl = com80d_1.jlas2 - j;
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
/* L75: */
	    au[l + au_dim1] -= rabc1[jl] * (ajk[l + (jl + 1) * ajk_dim1] -
		    ajk[l + (jl + 3) * ajk_dim1]);
	}
/* L80: */
    }

/*   CONTINUATION OF CALCULATION THE LAST SUM */

/*   THE COLUMN AU(L,3) IS USED AS WORKING ARRAY */

    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
/* L81: */
	au[l + au_dim1 * 3] = 0.f;
    }
    i__1 = km2;
    for (j = 1; j <= i__1; j += 2) {
	jl = com80d_1.jlas3 - j;
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
/* L85: */
	    au[l + au_dim1 * 3] += rabc1[jl] * (ajk[l + (jl + 1) * ajk_dim1]
		    - ajk[l + (jl + 3) * ajk_dim1]);
	}
/* L90: */
    }

    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
/* L91: */
	au[l + au_dim1] += au[l + au_dim1 * 3];
    }
    goto L95;

/*    CASE (EVENT) FOR K=3 */

L92:
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
/* L93: */
	au[l + au_dim1] += rabc1[1] * (ajk[l + (ajk_dim1 << 1)] - ajk[l + (
		ajk_dim1 << 2)]);
    }
/* -------------------------------------------------------- */
/* -------------------------------------------------------- */
L95:
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
	au[l + au_dim1] = (yx[l] + com70d_1.hd2 * dyx[l] + com80d_1.h2d32 * (
		ajk[l + ajk_dim1] * 3. - ajk[l + (ajk_dim1 << 1)] * 2. + ajk[
		l + ajk_dim1 * 3]) + com80d_1.h2d4 * au[l + (au_dim1 << 1)] -
		com80d_1.h2d8 * au[l + au_dim1]) * 2.;

	if (*k == 2) {
	    goto L96;
	}

	au[l + (au_dim1 << 1)] = com70d_1.hd2 * (dyx[l] + com70d_1.hd4 * (ajk[
		l + ajk_dim1] - ajk[l + (ajk_dim1 << 1)] * .75 + ajk[l + (
		ajk_dim1 << 2)] * .25) + com70d_1.hd2 * au[l + (au_dim1 << 1)]
		);
	goto L97;

L96:
	au[l + (au_dim1 << 1)] = com70d_1.hd2 * (dyx[l] + com70d_1.hd4 * (ajk[
		l + ajk_dim1] - ajk[l + (ajk_dim1 << 1)] * .75) +
		com70d_1.hd2 * au[l + (au_dim1 << 1)]);
	goto L99;

L97:
	if (*k == 3) {
	    goto L98;
	}

	au[l + au_dim1 * 3] = com80d_1.h2d96 * (ajk[l + ajk_dim1] * 3. - ajk[
		l + ajk_dim1 * 3] * 4. + ajk[l + ajk_dim1 * 5]);
L98:
	au[l + *k * au_dim1] = com80d_1.h2d16 * (rabc2[km1] * ajk[l + km2 *
		ajk_dim1] - rabc3[km1] * ajk[l + *k * ajk_dim1]);
L99:
	au[l + kp1 * au_dim1] = com80d_1.h2d16 * (rabc2[*k] * ajk[l + km1 *
		ajk_dim1] - rabc3[*k] * ajk[l + kp1 * ajk_dim1]);
	au[l + kp2 * au_dim1] = com80d_1.h2d16 * rabc2[kp1] * ajk[l + *k *
		ajk_dim1];
	au[l + kp3 * au_dim1] = com80d_1.h2d16 * rabc2[kp2] * ajk[l + kp1 *
		ajk_dim1];
/* L100: */
    }

    if (*k < 5) {
	goto L116;
    }
    i__1 = km2;
    for (i__ = 3; i__ <= i__1; ++i__) {
	im1 = i__ - 1;
	ip1 = i__ + 1;
	ip3 = i__ + 3;
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
/* L110: */
	    au[l + ip1 * au_dim1] = com80d_1.h2d16 * (rabc2[i__] * ajk[l +
		    im1 * ajk_dim1] - rabc3[i__] * ajk[l + ip1 * ajk_dim1] +
		    rabc2[ip1] * ajk[l + ip3 * ajk_dim1]);
	}
/* L115: */
    }

L116:
    if (*iexit == 1) {
	goto L130;
    }
    i__1 = *k;
    for (j = 1; j <= i__1; ++j) {
	de70dc_c(m, &kp1, &alpn[j], &adu[adu_offset], &du[j * du_dim1 + 1], &
		zfi[kp2 * zfi_dim1 + 1]);
	de70dc_c(m, &kp2, &alpn[j], &au[au_offset], &u[j * u_dim1 + 1], &zfi[
		kp2 * zfi_dim1 + 1]);
/* L120: */
    }
    if (*iexit == 2) {
	goto L130;
    }
    i__1 = *k;
    for (j = 1; j <= i__1; ++j) {
	(*f)(&xj0[j], &u[j * u_dim1 + 1], &du[j * du_dim1 + 1], &zfi[(j + 1) *
		 zfi_dim1 + 1], m);
/* L125: */
    }
    if (*iexit == 3) {
	goto L130;
    }
    de70dq_c(m, k, &zfi[zfi_offset], &cmar[cmar_offset], &ajk[ajk_offset]);
L130:
    return 0;
} /* de80di_c */



 int de80dk_c(integer *k, doublereal *rabc1, doublereal *rabc2,
	 doublereal *rabc3)
{
    /* System generated locals */
    integer i__1;

    /* Local variables */
    static integer j, kp2;

    /* Parameter adjustments */
    --rabc1;
    --rabc2;
    --rabc3;

    /* Function Body */
    kp2 = *k + 2;
    i__1 = *k;
    for (j = 1; j <= i__1; ++j) {
/* L10: */
	rabc1[j] = 1. / (doublereal) (j * (j + 1) * (j + 2));
    }
    i__1 = kp2;
    for (j = 2; j <= i__1; ++j) {
	rabc2[j] = 1. / (doublereal) (j * (j - 1));
/* L15: */
	rabc3[j] = 2. / (doublereal) (j * j - 1);
    }
    com80d_1.jlas = *k - *k % 2 + 2;
    com80d_1.jlas1 = *k + *k % 2 + 2;
    com80d_1.jlas2 = com80d_1.jlas - 2;
    com80d_1.jlas3 = com80d_1.jlas1 - 4;
    return 0;
} /* de80dk_c */


#ifdef __cplusplus
extern "C" {
#endif

#ifdef KR_headers
double d_sign(a,b) doublereal *a, *b;
#else
double d_sign(doublereal *a, doublereal *b)
#endif
{
double x;
x = (*a >= 0 ? *a : - *a);
return( *b >= 0 ? x : -x);
}
#ifdef __cplusplus
}
#endif
